component accessors="true" singleton{
	
	// Dependencies
	property name="sessionStorage" 		inject="coldbox:plugin:SessionStorage";
	property name="settings" 			inject="coldbox:modulesettings:databoss";
	property name="logger"			 	inject="logbox:logger:databoss";
	
	/**
	* Constructor
	*/
	SecurityService function init(){
		return this;
	}
	
	/**
	* Authorize with basic auth
	*/
	function authorize(required username, required password){
		
		// Validate Credentials
		if( settings.basicAuthentication.username eq arguments.username AND 
			settings.basicAuthentication.password eq arguments.password ){
			// Set simple validation
			sessionStorage.setVar("userAuthorized",  true );
			return true;
		}
		
		return false;
	}
	
	/**
	* Checks if user already logged in or not.
	*/
	function isLoggedIn(){
		if( sessionStorage.getVar( "userAuthorized", "false" ) ){
			return true;
		}
		return false;
	}

}
