/**
********************************************************************************
Ortus DataBoss
Copyright 2012 Ortus Solutions, Corp
www.ortussolutions.com
********************************************************************************
* An role entity
*/
component persistent="true" table="role" displayName="User Roles" db_sortBy="role"{

	// Primary Key
	property name="roleID" fieldtype="id" generator="native" setter="false";
	
	// Properties
	property name="role"  		ormtype="string" notnull="true" length="255" unique="true" default="" db_labelText="Role";
	property name="description" ormtype="string" notnull="false" default="" length="500" db_labelText="Role Description";
	
	// M2M -> Permissions
	property name="permissions" singularName="permission" fieldtype="many-to-many" type="array" lazy="extra" orderby="permission" cascade="all" 
			  cfc="Permission" fkcolumn="FK_roleID" linktable="cb_rolePermissions" inversejoincolumn="FK_permissionID"; 
	
	// Calculated Fields
	property name="numberOfPermissions" formula="select count(*) from cb_rolePermissions as rolePermissions where rolePermissions.FK_roleID=roleID";
	property name="numberOfUsers" 	formula="select count(*) from user as user where user.FK_roleID=roleID";
	
	// Constructor
	function init(){
		permissions 	= [];
		return this;
	}
	
}
