/**
********************************************************************************
Copyright 2012 Ortus Solutions, Corp
www.ortussolutions.com
********************************************************************************
* This is the DataBoss Standalone Application Configuration
*/
component {

	function configure(){

		// coldbox directives
		coldbox = {
			//Application Setup
			appName 				= "Ortus DataBoss",

			//Development Settings
			debugMode				= false,
			debugPassword			= "databoss",
			reinitPassword			= "databoss",
			handlersIndexAutoReload = false,

			//Implicit Events
			defaultEvent			= "databoss:databoss.index",
			requestStartHandler		= "",
			requestEndHandler		= "",
			applicationStartHandler = "",
			applicationEndHandler	= "",
			sessionStartHandler 	= "",
			sessionEndHandler		= "",
			missingTemplateHandler	= "",

			//Error/Exception Handling
			exceptionHandler		= "",
			onInvalidEvent			= "",
			customErrorTemplate		= "",

			//Application Aspects
			handlerCaching 			= true,
			eventCaching			= true
		};

		// custom settings
		settings = {
			// Style Overrides
			messagebox_style_override = true
		};

		// environment settings, create a detectEnvironment() method to detect it yourself.
		// create a function with the name of the environment so it can be executed if that environment is detected
		// the value of the environment is a list of regex patterns to match the cgi.http_host.
		environments = {
			development = "^cf10.,^railo.,^cf9,^localhost"
		};
		
		// localization (i18n)
		i18n = {
			defaultResourceBundle = "/DataBoss/modules/databoss/includes/i18n/main",
			defaultLocale = "en_US",
			localeStorage = "cookie"
		};

		//LogBox DSL
		logBox = {
			// Define Appenders
			appenders = {
				coldboxTracer = { class="coldbox.system.logging.appenders.ColdboxTracerAppender" }
			},
			// Root Logger
			root = { levelmax="INFO", appenders="*" },
			// Implicit Level Categories
			info = [ "coldbox.system" ]
		};

		//Layout Settings
		layoutSettings = {
			defaultLayout = "Main.cfm"
		};

		//Register interceptors as an array, we need order
		interceptors = [
			//SES
			{ class="coldbox.system.interceptors.SES" }
		];

		// ORM
		orm = {
			injection = { enabled = true }
		};
	}

	/**
	* Development overrides
	*/
	function development(){
		// Override directives
		coldbox.debugPassword			= "";
		coldbox.reinitPassword  		= "";
		coldbox.handlerCaching  		= false;
		coldbox.eventCaching			= false;
		coldbox.handlerIndexAutoReload  = true;
	}

}